Bug 733421 - fltk-config inconsistency on ARM
fltk-config inconsistency on ARM
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: fltk (Show other bugs)
14
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Rex Dieter
Fedora Extras Quality Assurance
:
Depends On:
Blocks: ARMTracker
  Show dependency treegraph
 
Reported: 2011-08-25 12:43 EDT by Daniel Drake
Modified: 2011-08-26 08:37 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-08-25 14:11:27 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
F14 build failure (39.26 KB, text/plain)
2011-08-26 04:31 EDT, Daniel Drake
no flags Details

  None (edit)
Description Daniel Drake 2011-08-25 12:43:54 EDT
The changes in #341141 introduce a headache for ARM. For Fedora 14 we are building for the armv5tel architecture configuration (armv7 systems can also run this code).

Our build farm and user-base is mixed armv5 and armv7. This means that the "arch" command doesn't return constant output.

Right now, fltk.spec is running the "arch" command to name the installed fltk-config-FOO script, and the fltk-config wrapper does:

   exec fltk-config-$(arch) "$@"

This can result in failures, such as when the build node runs armv5 (installing fltk-config-armv5), but the user runs armv7 (which would then look for the non-existend fltk-config-armv7).

One option to work around this would be to filter the output of the arch command, in both the spec file (used when naming the file to be installed) and in the fltk-wrapper (used when seeing the script to run). If the arch matches "arm*" then just use "arm". This would result in fltk-config-arm being constant on all arm systems.
Comment 1 Rex Dieter 2011-08-25 12:50:51 EDT
As mentioned on irc, I think there may be a world of hurt (affecting other packages as well), if $(arch) output doesn't match between the buildroot and target arch/environment.
Comment 2 Daniel Drake 2011-08-25 13:13:23 EDT
I'm new to ARM, but I guess that may be a valid point. Perhaps the existing attempts to be able to be able to run an armv5tel system on top of an armv7 kernel were misinformed.
Comment 3 Rex Dieter 2011-08-25 13:33:09 EDT
OK, spoke with dilmogre on irc, and peaked at how other packages (like mysql) deal with it.

1.  use `uname -i` instead of `arch`
2.  apply multilib-hacks only on targets that support multilib
Comment 4 Rex Dieter 2011-08-25 14:11:27 EDT
fixed in git for branches f16+:
%changelog
* Thu Aug 25 2011 Rex Dieter <rdieter@fedoraproject.org> 1.3.0-2
- fltk-config inconsistency on ARM (#733421)

and f14/f15 branches:
%changelog
* Thu Aug 25 2011 Rex Dieter <rdieter@fedoraproject.org> 1.1.10-7
- fltk-config inconsistency on ARM (#733421)
Comment 5 Daniel Drake 2011-08-26 04:31:20 EDT
Created attachment 520033 [details]
F14 build failure
Comment 6 Daniel Drake 2011-08-26 04:34:06 EDT
Thanks Rex. However, build now fails on F14, probably due the additional changes you merged in from F15.

It fails on both x86 and ARM in %check. build log attached aove.

I note that you have tests disabled on F15+ so perhaps the check just needs to be adjusted. But the check failure is quite different, compare the attached log against e.g. http://kojipkgs.fedoraproject.org/packages/fltk/1.1.10/6.fc15/data/logs/i686/build.log
Comment 7 Rex Dieter 2011-08-26 08:37:42 EDT
Followup fix for broken 'make test'

%changelog
* Fri Aug 26 2011 Rex Dieter <rdieter@fedoraproject.org> 1.1.10-8
- drop fluid_target patch, fixes tests

Note You need to log in before you can comment on or make changes to this bug.